> ## Documentation Index
> Fetch the complete documentation index at: https://developer.fabric.inc/llms.txt
> Use this file to discover all available pages before exploring further.

# Record customer agreement to delay shipment

> Record customer's agreement to delay the shipment.



## OpenAPI

````yaml backorders-preorders.openapi post /backorders-preorders/{id}/actions/save-delay-consent
openapi: 3.0.1
info:
  contact:
    email: support@fabric.inc
    name: fabric Orders Team
  description: >-
    fabric **Backorders and Preorders** refer to orders placed for products not
    currently available for shipment or sale. Backorders are orders for
    out-of-stock products that will be shipped to customers as soon as they're
    available for shipment. Preorders are orders for products that aren't yet
    available in the market, but will be launched for sale. Customers can
    preorder products, and the products will be shipped when they're available
    for sale. fabric's Backorders & Preorders API supports multi-tenant service.
  license:
    name: fabric Privacy Policy
    url: https://fabric.inc/api-license
  termsOfService: https://fabric.inc/terms-of-use
  title: Orders - Backorders Preorders API
  version: 3.0.0
  x-audience: external-public
servers:
  - description: Production
    url: https://api.fabric.inc/v3
security:
  - authorization: []
tags:
  - description: >-
      fabric **Backorders and Preorders** refer to orders placed for products
      not currently available for shipment or sale. Backorders are orders for
      out-of-stock products that will be shipped to customers as soon as they're
      available for shipment. Preorders are orders for products that aren't yet
      available in the market, but will be launched for sale. Customers can
      preorder products, and the products will be shipped when they're available
      for sale. fabric's Backorders & Preorders API supports multi-tenant
      service.
    name: Backorders Preorders
externalDocs:
  description: Find out more about fabric Orders (also called OMS)
  url: https://developer.fabric.inc/v3/docs/orders-overview
paths:
  /backorders-preorders/{id}/actions/save-delay-consent:
    post:
      tags:
        - Backorders Preorders
      summary: Record customer agreement to delay shipment
      description: Record customer's agreement to delay the shipment.
      operationId: saveDelayConsent
      parameters:
        - description: Unique ID for backorder or preorder
          example: 63ec576ddaa2544b2dd94684
          in: path
          name: id
          required: true
          schema:
            type: string
        - $ref: '#/components/parameters/xFabricTenantId'
        - $ref: '#/components/parameters/xFabricChannelId'
        - $ref: '#/components/parameters/xFabricRequestId'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/saveDelayConsentRequest'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/backOrderPreOrderResponse'
          description: OK
          headers:
            x-fabric-request-id:
              $ref: '#/components/headers/xFabricRequestIdResponseHeader'
        '400':
          content:
            application/json:
              example:
                errors:
                  - message: Invalid request
                    type: CLIENT_ERROR
                message: Bad request
                type: CLIENT_ERROR
              schema:
                $ref: '#/components/schemas/errorResponse'
          description: Bad request
          headers:
            x-fabric-request-id:
              $ref: '#/components/headers/xFabricRequestIdResponseHeader'
        '401':
          content:
            application/json:
              example:
                message: Unauthorized request
                type: CLIENT_ERROR
              schema:
                $ref: '#/components/schemas/errorResponse'
          description: Unauthorized
          headers:
            x-fabric-request-id:
              $ref: '#/components/headers/xFabricRequestIdResponseHeader'
        '404':
          content:
            application/json:
              example:
                message: Reservation not found
                type: CLIENT_ERROR
              schema:
                $ref: '#/components/schemas/errorResponse'
          description: Not found
          headers:
            x-fabric-request-id:
              $ref: '#/components/headers/xFabricRequestIdResponseHeader'
        '500':
          content:
            application/json:
              example:
                message: Internal server error
                type: SERVER_ERROR
              schema:
                $ref: '#/components/schemas/errorResponse'
          description: Internal server error
          headers:
            x-fabric-request-id:
              $ref: '#/components/headers/xFabricRequestIdResponseHeader'
components:
  parameters:
    xFabricTenantId:
      description: >-
        A header used by fabric to identify the tenant making the request. You
        must include tenant id in the authentication header for an API request
        to access any of fabric’s endpoints. You can retrieve the tenant id ,
        which is also called account id, from
        [Copilot](/v3/platform/settings/account-details/getting-the-account-id).
        This header is required.
      example: 5f328bf0b5f328bf0b5f328b
      in: header
      name: x-fabric-tenant-id
      required: true
      schema:
        type: string
    xFabricChannelId:
      description: >-
        x-fabric-channel-id identifies the sales channel where the API request
        is being made; primarily for multichannel use cases. The channel ids are
        12 corresponding to US and 13 corresponding to Canada. The default
        channel id is 12. This field is required.
      example: '12'
      in: header
      name: x-fabric-channel-id
      required: true
      schema:
        type: string
    xFabricRequestId:
      description: Unique request ID
      example: 263e731c-45c8-11ed-b878-0242ac120002
      in: header
      name: x-fabric-request-id
      required: false
      schema:
        type: string
  schemas:
    saveDelayConsentRequest:
      description: Delay consent request
      properties:
        consent:
          description: Consent type
          enum:
            - ACCEPT
            - DECLINE
          example: ACCEPT
          type: string
      required:
        - consent
      type: object
    backOrderPreOrderResponse:
      description: Backorder-preorder response details
      properties:
        cartId:
          description: >-
            fabric system-generated cart ID. This ID identifies the cart for
            which backorder and preorder is created.
          example: b03b72dc-78d8-4ea4-90fc-2fe6a1fe6569
          type: string
        consentReceivedAt:
          description: >-
            The fabric system-generated time of customer consent. This field is
            used in combination with the `isDelayConsented` field.
          example: '2022-07-12T09:30:31.198Z'
          format: date-time
          type: string
        createdAt:
          description: The date the backorder or preorder was created.
          example: '2022-07-11T15:03:14.642Z'
          format: date-time
          type: string
        id:
          description: System-generated unique ID for backorder or preorder
          example: 63ec576ddaa2544b2dd94684
          type: string
        isDelayConsented:
          description: >-
            true: Customer agrees to receive the product at a later date false:
            Customer wants the product immediately, and doesn't agree to receive
            the product at a later date. In such case, if the merchant can't
            fulfill the order immediately, they can cancel the product, change
            order status and notify the customer about order cancellation
          example: true
          type: boolean
        itemId:
          description: >-
            System-generated unique identifier of item from fabric Products
            (previously called PIM) service
          example: 123
          format: int32
          type: integer
        lastNotifiedAt:
          description: >-
            System-generated time of last notification to customer about their
            order
          example: '2022-06-12T09:30:31.198Z'
          format: date-time
          type: string
        lineItemId:
          description: Item sequence ID generated by fabric Orders (also called fabric OMS)
          example: '0'
          type: string
        lineItemStatus:
          description: Line item status
          enum:
            - CANCELLED
            - REFUNDED
            - PARTIALLY_CANCELLED
            - PARTIALLY_REFUNDED
            - PARTIALLY_CANCELLED_REFUNDED
            - VALID
            - EXCHANGED
            - PENDING_EXCHANGE
            - RETURN
            - PARTIAL_RETURN
            - PENDING_RETURN
            - RETURN_PROCESSING
            - RETURN_REJECTED
            - ORDER_LINE_INVALID_SKU
            - ORDER_LINE_VALID
            - SHIPPED
            - PARTIALLY_SHIPPED
            - ALLOCATED
            - PARTIALLY_ALLOCATED
            - DELIVERED
            - PARTIALLY_DELIVERED
            - PICKED_UP
            - PARTIALLY_PICKED_UP
            - READY_FOR_PICKUP
            - READY_FOR_PARTIAL_PICKUP
          example: CANCELLED
          type: string
        locationNumber:
          description: >-
            Represents inventory location which will fulfill the order
            reservation
          example: WH334
          type: string
        orderId:
          description: System-generated order ID created during order creation
          example: 5fec576ddaa2544b2dd94684
          type: string
        orderNumber:
          description: System-generated order number created during order creation
          example: order_123
          type: string
        orderStatusCode:
          description: Order status
          enum:
            - ORDER_CREATED
            - ORDER_PARTIALLY_ALLOCATED
            - ORDER_ALLOCATED
            - ORDER_SHIPPED
            - ORDER_PARTIALLY_SHIPPED
            - ORDER_PICKED_UP
            - ORDER_PARTIALLY_PICKED_UP
            - ORDER_READY_FOR_PICKUP
            - ORDER_READY_FOR_PARTIAL_PICKUP
            - ORDER_DELIVERED
            - ORDER_PARTIALLY_DELIVERED
            - ORDER_RETURNED
            - ORDER_PARTIALLY_RETURNED
            - ORDER_PENDING_RETURN
            - ORDER_PENDING_PARTIAL_RETURN
            - ORDER_PARTIALLY_EXCHANGED
            - ORDER_EXCHANGED
            - ORDER_CANCELLED
            - ORDER_PARTIALLY_CANCELLED
            - ORDER_HOLD
            - ORDER_CONFIRMED
            - ORDER_HOLD_FRAUD
            - ORDER_HOLD_CSR
            - ORDER_HOLD_CROSSBORDER
            - ORDER_HOLD_REVALIDATION
            - ORDER_ERROR
            - ORDER_HOLD_AUTH_PENDING
          example: ORDER_CREATED
          type: string
        orderedAt:
          description: System-generated order creation time
          example: '2022-04-12T09:30:31.198Z'
          format: date-time
          type: string
        quantity:
          description: Number of items reserved for backorder or preorder
          example: 5
          format: int32
          type: integer
        releasedQuantity:
          description: Number of items to be released from inventory reservation
          example: 1
          format: int32
          type: integer
        sku:
          description: Stock Keeping Unit (SKU), unique identifier of item
          example: sku_123
          type: string
        status:
          description: Backorder or preorder status
          example: PARTIAL_BACK_PREORDER_RELEASE
          type: string
        type:
          description: Reservation type
          enum:
            - PREORDER
            - BACKORDER
          example: BACKORDER
          type: string
        updatedAt:
          description: The date the backorder or preorder was updated.
          example: '2022-07-11T15:03:14.642Z'
          format: date-time
          type: string
        vendorId:
          description: ID of the retailer's source of order replenishment
          example: vendor_123
          type: string
      required:
        - lineItemId
        - locationNumber
        - orderId
        - orderStatusCode
        - orderedAt
        - quantity
        - sku
        - type
      type: object
    errorResponse:
      description: Error response
      properties:
        errors:
          description: Errors
          items:
            $ref: '#/components/schemas/errorResponse'
          type: array
        message:
          description: Error message
          example: Bad request
          type: string
        type:
          description: Error type
          example: CLIENT_ERROR
          type: string
      type: object
  headers:
    xFabricRequestIdResponseHeader:
      description: Unique request ID
      example: 263e731c-45c8-11ed-b878-0242ac120002
      required: false
      schema:
        type: string
  securitySchemes:
    authorization:
      bearerFormat: JWT
      scheme: bearer
      type: http

````